unit adxRTD_Demo_IMPL;

interface

uses
  SysUtils, Classes, ComServ, adxRTD_Demo_TLB, adxRTDServ, StdVcl,
  Variants, DB, DBTables;

type
  TADX_RTD_DB_DEMO = class(TadxRTDServer, IADX_RTD_DB_DEMO);

  TRTDServerModule = class(TadxXLRTDServerModule)
    Table1: TTable;
    adxRTDTopic1: TadxRTDTopic;
    Table1CustNo: TFloatField;
    Table1Company: TStringField;
    Table1Addr1: TStringField;
    Table1Addr2: TStringField;
    Table1City: TStringField;
    Table1State: TStringField;
    Table1Zip: TStringField;
    Table1Country: TStringField;
    Table1Phone: TStringField;
    Table1FAX: TStringField;
    Table1TaxRate: TFloatField;
    Table1Contact: TStringField;
    Table1LastInvoiceDate: TDateTimeField;
    function adxRTDTopic1RefreshData(Sender: TObject): OleVariant;
    procedure adxXlRTDServerModuleRTDInitialize(Sender: TObject);
    procedure adxXlRTDServerModuleRTDFinalize(Sender: TObject);
  private
  protected
  public
  end;

implementation

{$R *.dfm}

procedure TRTDServerModule.adxXlRTDServerModuleRTDInitialize(Sender: TObject);
begin
  Table1.Active := True;
end;

procedure TRTDServerModule.adxXlRTDServerModuleRTDFinalize(Sender: TObject);
begin
  Table1.Active := False;
end;

function TRTDServerModule.adxRTDTopic1RefreshData(Sender: TObject): OleVariant;
var
  Topic: TadxRTDTopic;
  Field: TField;
  CustNo: Integer;
  FieldName: string;
begin
  Result := 'not found';
  Topic := Sender as TadxRTDTopic;
  FieldName := Topic.String02;
  CustNo := 0;
  try
    CustNo := StrToInt(Topic.String01);
  except
  end;

  if CustNo <> 0 then
    if Table1.Locate('CustNo', VarArrayOf([CustNo]), []) then begin
      Field := Table1.FindField(FieldName);
      if Field <> nil then Result := Field.AsString;
    end;
end;

initialization
  TadxRTDFactory.Create(ComServer, TADX_RTD_DB_DEMO, CLASS_ADX_RTD_DB_DEMO, TRTDServerModule);

end.
